#include "stdio.h"
#include "signer.h"

class Brute: public Signer
{
private:
  char key[164];
public:
  Brute(const char *szLogin, const char *szKeyFile);
  bool ok;
  bool checkpass(const char *pass);
};

Brute::Brute(const char *szLogin, const char *szKeyFile):Signer(szLogin, "", "") {
  FILE *f;
  f=fopen(szKeyFile,"rb");
  if (f) {
    ok=fread(key,1,164,f);
    fclose(f);
  } else ok=false;
}

bool Brute::checkpass(const char *pass) {
  char buf[164]; 
  m_szPassword = pass;
  memcpy(buf,key,164);

  SecureKeyByIDPW(buf,164);
  ((KeyFileFormat *)buf)->wSignFlag = 0;
  return !keys.LoadFromBuffer(buf,164);
}

int main(int argc, char *argv[]) {
  char testpass[8] = "";

  if (argc<3) {
    printf("Usage: %s wmid keyfile\n",argv[0]);
    return 1;
  }

  Brute bruter(argv[1],argv[2]);
  if (!bruter.ok) {
    printf("File not found: %s\n",argv[2]);
    return 1;
  }
  int i,j,k;
  for (i=1;i<8;++i) {
    testpass[i]=0;
    k=i-1;
    testpass[k]=' ';
    for(;;) {
      while(testpass[k]<='~') {
        if (bruter.checkpass(testpass)) {
           printf("Success - password: %s\n",testpass);
           return 0;
        }
        ++testpass[k];
      }
      testpass[k]=' ';
      while(--k>=0 && testpass[k]=='~') testpass[k]=' ';
      if (k<0) break;
      ++testpass[k];
      k=i-1;
    }
  }

  printf("Failed - password not found\n");
  return 0;
}
